SystemOrganization addCategory: #'EjerciciosPoo-Distance'!

Object subclass: #Distance
	instanceVariableNames: 'unit amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Distance class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
newWith: aValue unit: aDistanceUnit
	^self new initializeWith: aValue unit: aDistanceUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:41'!
* aNumber
	^Distance newWith:  (amount *aNumber) unit: unit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:41'!
+ aDistance
| aDistanceOfSameUnit |

	aDistanceOfSameUnit := aDistance convertTo: unit.
	^Distance newWith:  amount + (aDistanceOfSameUnit amount)  unit: unit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:41'!
- aDistance
	^self + aDistance negated.
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:41'!
/ aNumber
	^Distance newWith:  (amount / aNumber) unit: unit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
< aDistance
	^((self uniformValue)  < aDistance uniformValue).
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
<= aDistance
	^((self uniformValue) <= aDistance uniformValue).
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:39'!
= aDistance
	(aDistance isKindOf: self class) 
				ifTrue: [^(self uniformValue = aDistance uniformValue) and: (self unit class = aDistance unit class).]
				ifFalse: [^false].! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
> aDistance
"^((self uniformValue)  > aDistance uniformValue)."
	^ (self <= aDistance) not.
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
>= aDistance
"^((self uniformValue)  >= aDistance uniformValue)."
	^ (self < aDistance) not.
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
amount
	^amount.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
between: minDistance and: maxDistance
	"Answer whether the receiver is less than or equal to the argument, max, 
	and greater than or equal to the argument, min."
	^self uniformValue between: (minDistance uniformValue) and: (maxDistance uniformValue).! !

!Distance methodsFor: 'accessing' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
convertTo: aMeasureUnit 
	^aMeasureUnit convert: self amount from: (self unit).
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
hash
 	^self uniformValue hash.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
initializeWith: aValue unit: aDistanceUnit
	amount:=aValue.
	unit:=aDistanceUnit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
max: aDistance 
	(self>aDistance) 
					ifTrue: [^self ]
					ifFalse: [^aDistance].! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
min: aDistance 
	(self<aDistance) 
					ifTrue: [^self ]
					ifFalse: [^aDistance].! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:40'!
negated
	^Distance newWith:  amount * (-1)  unit: unit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
printOn: aStream
	aStream print: amount;
			 nextPutAll: ' '.
      unit printOn: aStream.
      (amount>1) ifTrue:[ aStream nextPutAll: 's'].

! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
to: aDistance
	^IntervalOfDistance from: self   to: aDistance.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
to: aDistance by: aDistanceStep
	^IntervalOfDistance from: self to: aDistance by: aDistanceStep.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
uniformValue
	^unit uniformValue: amount.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:29'!
unit
	^unit.! !

Object subclass: #DistanceUnit
	instanceVariableNames: 'factor name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:35'!
centimeter
	^self new: 'centimeter' factor: 10.! !

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:35'!
decameter
	^self new: 'decameter' factor: 10000.! !

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:36'!
decimeter
	^self new: 'decimeter' factor: 100.! !

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:36'!
hectometer
	^self new: 'hectometer' factor: 100000.! !

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:36'!
kilometer
	^self new: 'kilometer' factor: 1000000.! !

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:36'!
meter
	^self new: 'meter' factor: 1000.! !

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:36'!
milimeter
	^self new: 'milimeter' factor: 1.! !

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:32'!
new: aName factor: aFactor
	^self new initializeWith: aName factor: aFactor.! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:32'!
= aMeasureUnit
	(aMeasureUnit isKindOf: self class) 
				ifTrue: [^((self factor) = (aMeasureUnit factor)).]
				ifFalse: [^false].
	! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:33'!
convert: anAmount from: aDistanceUnit
| newValue |
	newValue := (aDistanceUnit uniformValue: anAmount) / (self factor).
	^Measure newWith:  newValue unit: self.! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:32'!
factor
	^factor.! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:32'!
initializeWith: aName factor: aFactor
	name:=aName.
	factor:=aFactor.! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:32'!
printOn: aStream
	aStream nextPutAll: name.! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:33'!
uniformValue: aValue
	^aValue * factor! !

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceTest methodsFor: 'distance units' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:33'!
centimeter
"	self error: 'Este metodo debe devolver el objeto que la unidad de distancia centimetro'"
	^DistanceUnit centimeter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:33'!
decameter
	"self error: 'Este metodo debe devolver el objeto que la unidad de distancia decametro'"
	^DistanceUnit decameter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:33'!
decimeter
	"self error: 'Este metodo debe devolver el objeto que la unidad de distancia decimetro'"
	^DistanceUnit decimeter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 19:41'!
distancesExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
hectometer
	"self error: 'Este metodo debe devolver el objeto que la unidad de distancia hectometro'"
	^DistanceUnit hectometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
kilometer
	"self error: 'Este metodo debe devolver el objeto que la unidad de distancia kilometro'"
	^DistanceUnit kilometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
meter
"self error: 'Este metodo debe devolver el objeto que la unidad de distancia metro'"
	^DistanceUnit meter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
millimeter
	"self error: 'Este metodo debe devolver el objeto que la unidad de distancia millimetro'"
	^DistanceUnit milimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
minusOneMeter 
"	self error: 'Este metodo debe devolver un objeto que represente un metro'"
		^Distance newWith: -1 unit: (DistanceUnit meter).! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
oneCentimeter
"	self error: 'Este metodo debe devolver un objeto que represente un centimetro'"
	^Distance newWith: 1 unit: (self centimeter).! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
oneHundredCentimeters
"	self error: 'Este metodo debe devolver un objeto que represente cien centimetros'"
	^Distance newWith: 100 unit: (self centimeter).! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
oneMeter
"	self error: 'Este metodo debe devolver un objeto que represente un metro'"
	^Distance newWith: 1 unit: (self meter).! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'GabrielBursztynPabloSatelier 5/21/2012 20:25'!
test01ObjectsRepresentingSameDistanceShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:26'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GabrielBursztyn 5/22/2012 01:12'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:26'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GabrielBursztynPabloSatelier 5/21/2012 21:01'!
test07bDistanceUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'GabrielBursztyn 5/22/2012 01:17'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'GabrielBursztyn 5/22/2012 01:20'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"

	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:40'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 19:35'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 19:35'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:48'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/21/2011 17:24'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 19:46'!
test21DistancesProvideATotalOrder

	self assert: (self distancesExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:11'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distancesExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:12'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distancesExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distancesExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 20:45'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by = self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.	
		

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 20:36'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 21:07'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |

	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:27'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
twoHundredCentimeters
"	self error: 'Este metodo debe devolver un objeto que represente doscientos centimetros'"
	^Distance newWith: 200 unit: (self centimeter).! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
twoMeters
"	self error: 'Este metodo debe devolver un objeto que represente dos metros'"
	^Distance newWith: 2 unit: (self meter). ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:34'!
zeroMeters
"self error: 'Este metodo debe devolver un objeto que represente cero metros'"
	^Distance newWith: 0 unit: (self meter). ! !

Interval subclass: #IntervalOfDistance
	instanceVariableNames: 'unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!IntervalOfDistance class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 20:26'!
from: startDistance to: stopDistance
	"Answer an instance of me, starting at startDistance, ending at 
	stopDistance, and with an interval increment of 1."
	^self 
		from: startDistance 
		to: stopDistance 
		by: (Measure newWith: 1 unit: (startDistance unit) )
! !

!IntervalOfDistance class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 20:38'!
from: startDistance to: stopDistance by: aDistanceStep 
	"Answer an instance of me, starting at startDistance, ending at 
	stopDistance, and with an interval increment of aDistanceStep."
	^self new
		setFrom: (startDistance uniformValue )
		to: (stopDistance uniformValue)
		by: (aDistanceStep uniformValue)
		unit: (startDistance unit )! !

!IntervalOfDistance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:41'!
by

	^Distance newWith: step  unit: DistanceUnit   milimeter! !

!IntervalOfDistance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:42'!
do: aBlock
	"Evaluate aBlock for each value of the interval.
	Implementation note: instead of repeatedly incrementing the value
		aValue := aValue + step.
	until stop is reached,
	We prefer to recompute value from start
		aValue := start + (index * step).
	This is better for floating points accuracy, while not degrading Integer and Fraction speed too much.
	Moreover, this is consistent with methods #at: and #size"

	| aValue index size |
	index := 0.
	size := self size.
	[index < size]
		whileTrue: [aValue := 			
			(Distance newWith:  start unit: (DistanceUnit milimeter))
			+
			(Distance newWith:  step unit: (DistanceUnit milimeter)) convertTo: unit * index.
			index := index + 1.
			aBlock value: aValue]! !

!IntervalOfDistance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:42'!
from
	^Distance newWith: start  unit: DistanceUnit milimeter.! !

!IntervalOfDistance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/23/2012 20:22'!
setFrom: startInteger to: stopInteger by: stepInteger unit: aDistanceUnit
	self setFrom: startInteger to: stopInteger by: stepInteger.
	unit := aDistanceUnit.
! !

!IntervalOfDistance methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 5/30/2012 21:42'!
to
	^Distance newWith: stop  unit: DistanceUnit milimeter.! !
